
// =======================================
// Programmer	:Luqman Hakim Bin Yusof
// Title		:Standart Setting
// =======================================

#include <pic.h>


// ==========================================
// Reference Prototype
// ==========================================

void init_io ( void ) ;
void init_serial ( void ) ;
void setup_digital (void) ;
unsigned char read_adc ( unsigned char channel) ;
void delay (unsigned long i) ;
void setup_adc ( void ) ; // optional for ADC


// ==========================================
// Subroutines Prototype
// ==========================================

void init_io ( void )
{
	TRISA = 0b11111111;
	TRISB = 0b11111111;
	TRISC = 0b00000000;
	TRISD = 0b00000000;
	TRISE = 0b00000000;

	PORTA = 0b00000000;
	PORTB = 0b00000000;
	PORTC = 0b00000000;
	PORTD = 0b00000000;
	PORTE = 0b00000000;
}

void setup_adc ( void )
{
	ADCON0 = 0b10000000;	//Left justified, RA0, RA1 and RA3 as ADC input
	ADCON1 = 0b01000100;	//Fosc/32, channel 0, ADC not active, ADC off
}

void setup_digital (void) 
{
	ADCON0 = 0b10000000;	//all adc is digital output
	ADCON1 = 0b01000111;	
}



unsigned char read_adc ( unsigned char channel )
{
	switch (channel)
	{
		case 1:
		ADCON0 = 0b10000001;
		break;
		case 2:
		ADCON0 = 0b10001001;
		break;
		case 3:
		ADCON0 = 0b10011001;
		break;
		default:
		ADCON0 = 0b10000000;
	}
	
	delay(5); 			// delay for a while
	ADGO = 1;			// start conversion
	while (ADGO) continue;
	ADON = 0;			// Off ADC module
	return ADRESH;		// return ADC result
}

void delay (unsigned long i)
{
	for (; i>0; i-=1);
}